"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var _1 = require("../../");
var _2 = require("../../unstable/");
var basicPokedexSchema = {
    type: 'object',
    properties: {
        Name: {
            type: 'string'
        },
        Height: {
            type: 'number'
        },
        Weight: {
            type: 'number'
        },
        Description: {
            type: 'string'
        },
        Category: {
            type: 'string'
        },
        Abilities: {
            type: 'string'
        },
        pokedex_number: {
            title: 'National Pokedex Number',
            type: 'number'
        },
        caught: {
            type: 'boolean'
        },
        first_seen: {
            title: 'First seen',
            type: 'string',
            format: 'date-time'
        }
    }
};
var FormDemo = (function (_super) {
    __extends(FormDemo, _super);
    function FormDemo(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            formData: {}
        };
        return _this;
    }
    FormDemo.prototype.change = function (_a) {
        var formData = _a.formData;
        react_1.action('Form.onChange')(formData);
        this.setState({ formData: formData });
    };
    FormDemo.prototype.submit = function (data) {
        react_1.action('Form.onSubmit')(data);
    };
    FormDemo.prototype.render = function () {
        var _this = this;
        return (React.createElement(_1.Flex, null,
            React.createElement(_1.Box, { flex: '1', m: 30 },
                React.createElement(_2.Form, __assign({ onChange: function (d) { return _this.change(d); }, onSubmit: function (d) { return _this.submit(d); }, value: this.state.formData }, this.props))),
            React.createElement(_1.Box, { flex: '1', p: 30 },
                React.createElement(_1.Txt, { monospace: true },
                    React.createElement("pre", null, JSON.stringify(this.state.formData, null, 4))))));
    };
    return FormDemo;
}(React.Component));
react_1.storiesOf('[beta] Form', module)
    .addWithInfo('Simple', function () {
    return React.createElement(FormDemo, { schema: basicPokedexSchema });
})
    .addWithInfo('Hidden submit button', function () {
    return React.createElement(FormDemo, { schema: basicPokedexSchema, hideSubmitButton: true });
})
    .addWithInfo('Custom submit button text', function () {
    return React.createElement(FormDemo, { schema: basicPokedexSchema, submitButtonText: 'Save' });
})
    .addWithInfo('UI schema', function () {
    return (React.createElement(FormDemo, { schema: basicPokedexSchema, uiSchema: {
            'ui:order': ['Name', 'caught', 'Description', 'Abilities', '*']
        } }));
})
    .addWithInfo('Preset values', function () {
    return (React.createElement(FormDemo, { schema: basicPokedexSchema, value: {
            Name: 'Squirtle'
        } }));
});
